**

** EPSON, GEMINI, MICROLINE 82/83/92/93, NEC-8023 CITOH-8510

** MPI GRAPHICS

**

**	COPYRIGHT 1981, 1982, 1983, 1984 LINDLEY SYSTEMS

**

**	04/12/85 V3.4A	19:00

**	

**	03/07/81 ORIGINAL VERSION FOR BASE2

**	04/14/81 ADDED "QZ" MARKER FOR DATA INSERTION

**	06/18/81 ADDED READY ENTRY AND HDOS 2.0 ASM FIXES

**	10/04/81 INVERSE VIDEO TAB FIX

**	10/24/81 FIX GRAPHIC SPACE => A

**	01/23/82 EPSON MX VERSION

**	02/06/82 ADDED DIRECT I/O

**	03/06/82 PERCOM I/O

**	04/07/82 PERCOM LOW READY

**	07/05/82 V1.2 6X12 DOT MATRIX

**	09/12/82 V2.0 COMMON I/O

**	12/18/82 V2.1 MX-100 LINE LENGTH UPDATE

**	02/20/83 V2.2 Assembly switch fix

**	10/09/83 V2.3 FIX FOR ED-A-SKETCH

**	03/31/84 V3.0 DOUBLE WIDTH & HEIGHT + NEC

**	05/10/84 V3.0 ADDED MPI CODE

**	05/24/84 V3.0a Microline 82/92 fix

**	07/17/84 V3.1 H-8 SIGNON, ROW & COLUMN FIX

**	09/30/84 V3.2 ML-84 GRAPHICS CODE ADDED

**	10/06/84 V3.3 MPI EXTRA '6' DELETED

**	03/03/85 V3.4 NO LF ON HOME IF COLUMN IS 0

**	04/23/85 V3.4A REFIX HOME FOR NO BLANK LINE

**

** PRINTER SELECTION

*

* IF HDOS

*OFF	EQU	1

*ON	EQU	0

* ENDIF

* IF CPM

OFF	EQU	0

ON	EQU	1

* ENDIF

CPM	EQU	ON

HDOS	EQU	OFF

*

MX	EQU	ON	; EPSON/STAR

ML82	EQU	OFF	; MICROLINE 82/83

ML84	EQU	OFF	; MICROLINE 84

ML92	EQU	OFF	; MICROLINE 92/93

NC	EQU	OFF	; NEC-8023, CITOH-8510

MPI	EQU	OFF	; MPI 88G 99G 150

*

 IF HDOS

ML	EQU	ML82+ML84+ML92-2

ML8292	EQU	ML82+ML92-1

ML8492	EQU	ML84+ML92-1

MXML84	EQU	MX+ML84-1

COUNT	EQU	MX+ML84+NC-2

 ENDIF

 IF CPM

ML	EQU	ML82 OR ML92 OR ML84

ML8292	EQU	ML82 OR ML92

ML8492	EQU	ML84 OR ML92

MXML84	EQU	MX OR ML84

COUNT	EQU	MX OR ML84 OR NC

 ENDIF

STX	EQU	2	; END ML GRAPHICS

ETX	EQU	3	; BEGIN ML GRAPHICS

LF	EQU	10

FF	EQU	12

CR	EQU	13

SI	EQU	15

CAN	EQU	24

ESC	EQU	27	; ESCAPE CODE

RS	EQU	30

*

* BIOS INTERFACE HEADER

	DW	PARAMS	; POINTER TO PARAMETER TABLE

RSTAD:	DW	RSTAD	; ADDRESS TO BE RESTORED

	JMP	SIGNON	; OUR SIGNON ROUTINE

LGOUT:	JMP	RSTAD	; GETS ADDRESS OF LPTOUT

*

* BEGINNING OF DRIVER CODE.  ORG + 0AH

GRCHAR: MOV	A,C	; GET CP/M CHARACTER

	ANI	177Q	; STRIP TOP BIT

	MOV	D,A

	ORA	A

	RZ		; SKIP NULLS

	LDA	LGST	; STATE GET STATE VARIABLE

	CALL	LGINX	; GO TO STATE

	DB	LGST0-$ ; TEST FOR LGCCC

	DB	LGST1-$ ; PROCESS COLUMN

	DB	LGST2-$ ; PROCESS ROW

	DB	LGST3-$ ; PROCESS ESCAPE

	DB	LGST4-$ ; PROCESS WIDTH

**

** STATE 0 - TEST FOR CONTROL CONVERSION

LGST0:	MOV	A,D

	CPI	27

	JZ	LGS0A

	LXI	H,LGCCC ; CONVERSION?

	CMP	M

	JNZ	LGOTPT

LGS0A:	LXI	H,LGST

	MVI	M,3	; ESCAPE PROCESS STATE

	RET

** STATE 1 - PROCESS COLUMN

LGST1:	LXI	H,LGST

	DCR	M	; STATE 0

	LXI	H,LGCX

	MOV	A,D

	SUI	32	; TO MATCH 0 TO 79

	MOV	C,A	; TARGET COLUMN

	MOV	A,M	; CURRENT COLUMN

	CMP	C

	RZ		; ON COLUMN ALREADY

	JC	LGS1A

	PUSH	PSW	; START NEW ROW

	CALL	LGENDL	; AS WE CAN'T GO BACK

	POP	PSW

LGS1A:	MVI	D,' '

	MOV	B,M

LGS1B:	MOV	A,M	; GET CURRENT COLUMN

	CMP	B	; (B) IS STARTING COLUMN

	RC		; RET IF LINE OVERFLOW

	CMP	C	; (C) IS TARGET COLUMN

	RZ		; DONE

	PUSH	PSW

	CALL	LGBC	; PUT A SPACE ON THE LINE

	POP	PSW

	JMP	LGS1B

** STATE 2 - PROCESS ROW

LGST2:	LXI	H,LGST

	DCR	M	; STATE ONE

	LXI	H,LGROW ; CURRENT ROW

	MOV	C,D	; TARGET ROW

	MOV	A,M

	CMP	C

	RZ		; ON ROW ALREADY

	JC	LGS2A

	CALL	LGENDL	; AS WE CAN'T GO BACK

	MOV	M,C	; MAKE THIS NEW ROW

	RET

LGS2A:	MOV	B,M

LGS2B:	MOV	A,M	; GET CURRENT ROW

	CMP	C	; (A) IS TARGET ROW

	RZ		; DONE

	CMP	B	; CHECK FOR NEW SCREEN

	RC		; MAY GET SET BACK TO ZERO

	PUSH	PSW

	CALL	LGENDL	; ENTER A LINE

	POP	PSW

	JMP	LGS2B

**

** STATE 4 - PROCESS WIDTH

LGST4:	LXI	H,LGST

	MVI	M,0

	MOV	A,D	; GET CHARACTER

	ANI	3

	JNZ	LGST4X

	MVI	A,4

LGST4X: STA	LGCURW

	JMP	LGFIX

**

** STATE 3 - PROCESS ESCAPE

LGST3:	LXI	H,LGST

	MVI	M,0

	MOV	A,D	; GET CHARACTER

	LXI	H,LGCCC ; CONTROL CONV CHAR

	CMP	M	; LOOK FOR TWO CCC'S

	JZ	LGOTPT

** CLASSIFY ESCAPE TYPE

	LXI	H,LGST

	CPI	'H'	; HOME CURSOR

	JNZ	LGS3A0

	LDA	LGCX

	ORA	A

	CNZ	LGENDL

	LXI	H,LGROW

	MVI	M,32	; SET TO TOP ROW

	RET

LGS3A0: CPI	'Y'	; CURSOR POSITION

	JNZ	LGS3A

	MVI	M,2	; PROCESS ROW AND COLUMN

	RET

LGS3A:	INX	H	; LGGRFL

	CPI	'F'

	JNZ	LGS3B

	MVI	M,1	; GRAPHICS ON

	RET

LGS3B:	CPI	'G'

	JNZ	LGS3C

	MVI	M,0	; GRAPHICS OFF

	RET

LGS3C:	INX	H	; LGIVFL

	CPI	112	; p

	JNZ	LGS3D

	MVI	M,1	; INVERSE ON

	RET

LGS3D:	CPI	113	; q

	JNZ	LGS3E

	MVI	M,0	; INVERSE OFF

	RET

LGS3E:	INX	H	; LGNLSW

	CPI	'@'

	JNZ	LGS3F

	MVI	M,1

	RET

LGS3F:	INX	H	; LGCURW

	CPI	'W'	; DOUBLE WIDTH

	JNZ	LGS3H

	LXI	H,LGST

	MVI	M,4

	RET

LGS3H:	INX	H	; LGDH

	CPI	'T'	; TALL HEIGHT

	JNZ	LGS3I

	MVI	M,1

	RET

LGS3I:	CPI	'S'	; SHORT HEIGHT

	JNZ	LGS3J

	MVI	M,0

	RET

LGS3J:	INX	H	; LGDSW

	CPI	'6'	; 6 DOTS/CHAR

	JNZ	LGS3K

	MVI	M,1

	JMP	LGFIX

LGS3K:	CPI	'8'	; 8 DOTS/CHAR

	JNZ	LGS3L

	MVI	M,0

	JMP	LGFIX

LGS3L:	CPI	'C'	; MAKE A SPACE

	JNZ	LGS3M

	MVI	D,' '

	JMP	LGBC

LGS3M:	CPI	'L'

	JZ	LGENDP

	LXI	H,LGCURD

	CPI	'1'

	JNZ	LGS3N

	MVI	M,0	; LOWEST DOT DENSITY

	JMP	LGFIX

LGS3N:	CPI	'2'

	JNZ	LGS3Q

	MVI	M,1	; NEXT DOT DENSITY

	JMP	LGFIX

LGS3Q:	CPI	'3'

	JNZ	LGS3R

	MVI	M,2	; NEXT DOT DENSITY

	JMP	LGFIX

LGS3R:	CPI	'4'

	JNZ	LGCLCF

	MVI	M,3	; HIGHEST DOT DENSITY

	JMP	LGFIX

LGCLCF: XRA	A

	RET

**

LGOTPT: MOV	A,D	; GET CURRENT CHARACTER

	CPI	32

	JNC	LGSEND

	CPI	FF

	JZ	LGENDP

	CPI	10

	JZ	LGENDL

** TEST FOR HORIZ TAB

LGTAB:	CPI	9

	JZ	LGTAB1

	XRA	A

	RET		; DUMP UNIDENTIFIED CONTROL

LGSEND: MOV	A,D

	CPI	'^'

	JC	LGDOIT	; NON-GRAPHIC

	LXI	H,LGGRFL

	MVI	A,1

	CMP	M

	JNZ	LGDOIT

	MOV	A,D

	SUI	95	; MOVE INTO GRAPHIC SET

	ANI	7FH	; DROP HIGH BIT

	MOV	D,A

LGDOIT: CALL	LGCKIV

	ORA	A

	CALL	LGBC

	RET

** PROCESS TAB CHARACTER

LGTAB1: MVI	D,' '

	CALL	LGCKIV	; INVERSE VIDEO CHECK

	ORA	A

	CALL	LGBC

	RC		; RET WITH XMIT ERROR

	LDA	LGCX

	ANI	7

	CPI	0	; COL 9,17,25,ETC.

	JNZ	LGTAB1

	RET

**

** TEST FOR INVERSE VIDEO REQUIREMENT

LGCKIV: LDA	LGIVFL

	ORA	A

	MOV	A,D	; GET CHAR

	RZ		; ZERO -> NORMAL

	ORI	80H	; SET INVERSE BIT

	MOV	D,A

	RET

**

** PROCESS NEW LINE CHARACTER

LGENDL: PUSH	H

	PUSH	D

	PUSH	B

	LXI	H,LGOVR

	MOV	A,M	; OVERFLOW INDICATOR

	MVI	M,0

	ORA	A

	JNZ	LGPOP	; OVERFLOW - SKIP ENDLINE

	LXI	H,LGNLSW

	MOV	A,M

	ORA	A

	MVI	M,0

	JNZ	LGPOP

	CALL	LGDOLN

	POP	B

	POP	D

	POP	H

	RET

**

** PROCESS NEW PAGE CHARACTER

LGENDP: CALL	LGENDL

	MVI	A,FF

	CALL	LGCHAR

	RET

**

** Enter character and print when the

** buffer is full

**   ENTRY:  (D) CHARACTER TO OUTPUT

**   EXIT:   CARRY SET ON XMIT ERROR

LGBC:	PUSH	H

	PUSH	D

	PUSH	B

	LXI	H,LGBUF

	LDA	LGCX

	CALL	DADA

	MOV	M,D	; (H,L) -> current character

	LXI	H,LGCX	; # of characters

	INR	M

	LDA	LGNCHL

	MOV	E,A

	CMP	M	; Buffer full?

	LXI	H,LGOVR

	MVI	M,0	; Show normal line

	JNC	LGPOP

	STA	LGCX

	INR	M	; Line overflow

	PUSH	D

	CALL	LGDOLN

	POP	D

	LXI	H,LGBUF

	MOV	M,D

	LXI	H,LGCX

	INR	M

LGPOP:	POP	B

	POP	D

	POP	H

	RET

**

** Output one line.

LGDOLN: LXI	H,LGROW

	INR	M	; UPDATE ROW

	LXI	H,LGBUF

	LDA	LGCX

	CALL	DADA

	XCHG

	LXI	H,LGCX

LGDO1:	MOV	A,M

	ORA	A

	JNZ	LGDO2

	CALL	LGNXT

	DB	CR,LF,0FFH

	RET

LGDO2:	DCX	D

	DCR	M

	LDAX	D

	CPI	20H

	JZ	LGDO1

	INR	M

	CALL	LGNXT

 IF ML82

LGDEN:	DB	30

 ENDIF

 IF ML8492

	DB	ESC,'%9',12

LGDEN:	DB	30

 ENDIF

 IF MX

	DB	ESC,'A',6

 ENDIF

 IF NC

	DB	CAN,SI,ESC,'>',ESC,'T12',ESC

LGDEN:	DB	'N'

 ENDIF

 IF MPI

	DB	ESC

LGDEN:	DB	31

 ENDIF

	DB	0FFH

	LXI	H,LGTBID ; Top identifier

	MVI	M,0	; Top of data

	MVI	A,0

	STA	LGDHI

	CALL	LGHLINE

	LDA	LGDH

	ORA	A

	JZ	LGDO3

	MVI	A,1

	STA	LGDHI

	CALL	LGHLINE

LGDO3:	LXI	H,LGTBID

	MVI	M,6	; Half of data

	MVI	A,0

	STA	LGDHI

	CALL	LGHLINE

	LDA	LGDH

	ORA	A

	JZ	LGDO4

	MVI	A,1

	STA	LGDHI

	CALL	LGHLINE

LGDO4:	CALL	LGNXT	; Exit Graphics

 IF ML

	DB	ESC,'6' ; 6 LINES/INCH

 ENDIF

 IF MX

	DB	ESC,'A',12 ; 6 LINES/INCH

 ENDIF

 IF NC

	DB	ESC,'<',ESC,'A' ; 6 LINES/INCH

 ENDIF

	DB	0FFH

	XRA	A	; Zero column count

	STA	LGCX

	RET

**

** Process half of one line.

LGHLINE: LXI	H,LGBUF ; Address of line buffer

	SHLD	LGCHP	; Line buffer origin

	CALL	LGNXT

; START GRAPHICS

 IF MX

	DB	ESC

LGDEN:	DB	'K'

 ENDIF

 IF ML8292

	DB	ETX

 ENDIF

 IF ML84

	DB	ESC,'%2'

 ENDIF

 IF NC

	DB	ESC,'S'

 ENDIF

 IF MPI

	DB	ESC,23

 ENDIF

	DB	0FFH

	LDA	LGCX

	MOV	L,A

	INR	A

	STA	LGCNT

 IF COUNT

	MOV	E,L

	MVI	H,0

	MOV	D,H

	DAD	H	; * 2

	LDA	LGDSW

	ORA	A

	JNZ	LGD1

	DAD	D	; * 3

LGD1:	DAD	D	; * 3	 * 4

	DAD	H	; * 6	 * 8

	LDA	LGCURW

	CPI	2

	JC	LGD2

	MOV	D,H

	MOV	E,L

	DAD	H

	JZ	LGD2

	DAD	D

	CPI	3

	JZ	LGD2

	DAD	D

 ENDIF

 IF ML84

LGD2:	DAD	H	; SHL

	MOV	A,H	; BITS 7 TO 13

	CALL	LGCHAR

	MOV	A,L

	RRC		; BITS 0 TO 6

	CALL	LGCHAR

 ENDIF

 IF MX

LGD2:	MOV	A,L

	CALL	LGCHAR

	MOV	A,H

	CALL	LGCHAR

 ENDIF

 IF NC

LGD2:	SHLD	LGVAL

	CALL	LGUDD4

 ENDIF

*

* Character loop - test for end of this line

LGL1:	LXI	H,LGCNT ; NR OF CHARACTERS TO DO

	DCR	M

	JNZ	LGL1A

	CALL	LGNXT

* Finish the line when done.

 IF ML82

	DB	ETX,STX,CR,ESC,'%9',12

 ENDIF

 IF ML92

	DB	ETX,STX,CR,LF

 ENDIF

 IF ML84

	DB	CR,LF

 ENDIF

 IF MX

	DB	CR,LF

 ENDIF

 IF NC

	DB	CR,LF

 ENDIF

 IF MPI

	DB	'6'

 ENDIF

	DB	0FFH

	RET

* Do one more character

LGL1A:	LHLD	LGCHP

	MOV	A,M	; Get character value

	INX	H

	SHLD	LGCHP

	ANA	A	; Look for reverse video

	MVI	E,00H	; Normal video

	JP	LGL2

	ANI	7FH	; Set table offset

	DCR	E	; Inverse video

LGL2:	PUSH	D

	MVI	H,0

	MOV	L,A	; Character offset

	DAD	H	; *2

	DAD	H	; *4

	MOV	E,L	; *4

	MOV	D,H

	DAD	H	; *8

	DAD	D	; *12

	LXI	D,LGDATA ; Data base address

	DAD	D	; Caracter address

	LDA	LGTBID	; Get top/bottom offset

	CALL	DADA

	POP	D      

	MVI	D,8

	DCX	H

	PUSH	H	; Character pointer

**

** Loop to get one output byte (6 bits)

**  Entry:

**	(B)	Input bit counter

**	(C)	Output bit counter

**	(D)	Output byte count

**	(E)	Inverse/Normal mask

**	(H)	Shifted bits for output

**	(L)	Bits being shifted

	MVI	B,1	; Show end of input bit count

LGB1:	MVI	C,6	; Schedule 6 output bits

LGB2:	DCR	B	; New input byte needed?

	JNZ	LGB3

	MOV	A,H	; Save partial shift

	POP	H	; Previous byte

	INX	H	; Point to current byte

	PUSH	H

	MOV	L,M	; Get byte

	MOV	H,A	; Restore unused bits

	MVI	B,8	; Restore input bit counter

LGB3:	DAD	H	; Double shift left

 IF ML8292

	MOV	A,H	; Get shifted bits

	RRC

	RRC

	MOV	H,A

 ENDIF

 IF NC

	MOV	A,H	; Get shifted bits

	RRC

	RRC

	MOV	H,A

 ENDIF

	DCR	C	; Output ready?

	JNZ	LGB2

**

** SEND CURRENT OUTPUT TO PRINTER

	LDA	LGDSW	; 0 => 8 BYTES/CHAR

	ORA	A	; 1 => 6

	JZ	LGB4

	MOV	A,D

	CPI	8

	JZ	LGB6

	CPI	1

	JZ	LGB6

LGB4:	MOV	A,H	; Get shifted bits

	XRA	E	; Normal/Inverse video

 IF ML8292

	ANI	7EH	; Save middle 6 bits

 ENDIF

 IF ML84

	ANI	3FH	; Save low 6 bits

	RLC		; Put in middle

 ENDIF

 IF MX

	ANI	3FH	; Save low 6 bits

	RLC		; Put in middle

 ENDIF

 IF NC

	ANI	7EH	; Save middle 6 bits

 ENDIF

 IF MPI

	ANI	3FH	; Save low 6 bits

	RLC		; Put in middle

 ENDIF

	PUSH	B

	MOV	B,A

	LDA	LGDH	; Check for double height

	ORA	A

	MOV	A,B

	JZ	LGB4G

	LDA	LGDHI	; Process doulble height

	ORA	A

	MOV	A,B

 IF ML8292

	JNZ	LGB4A

 ENDIF

 IF ML84

	JZ	LGB4A

 ENDIF

 IF MX

	JZ	LGB4A

 ENDIF

 IF NC

	JNZ	LGB4A

 ENDIF

 IF MPI

	JZ	LGB4A

 ENDIF

	RLC	; Use 2nd half of data

	RLC

	RLC

**		  C    A

LGB4A:	RLC	; X 012XXXXX

	RLC	; 0 12XXXXX0

	RAR	; 0 012XXXXX

	RAR	; X 0012XXXX

	RLC	; 0 012XXXX0

	RLC	; 0 12XXXX00

	RLC	; 1 2XXXX001

	RAL	; 2 XXXX0011

	RAL	; X XXX00112

	RRC	; 2 2XXX0011

	RAL	; 2 XXX00112

	RAL	; X XX001122

	RAL	; X X001122X

	ANI	07EH	; X -001122-

LGB4G:	PUSH	H

	LXI	H,LGCURW

	MOV	B,M

 IF MPI

	RAR		; move to low end

	ANI	03FH

	ORI	040H	; MPI Graphics indicator

 ENDIF

LGB4H:	PUSH	PSW

	CALL	LGCHAR

	POP	PSW

	DCR	B

	JNZ	LGB4H

** Test for end of character

LGB5:	POP	H

	POP	B

LGB6:	DCR	D

	JNZ	LGB1	; Get next byte of 6 bits

	POP	B	; Clear stack

	JMP	LGL1	; and get next character

**

** PRINT INLINE UP TO DELETE CODE

LGNXT:	XTHL

	CALL	LGRLP

	XTHL

	RET

LGRLP:	MOV	A,M

	INX	H

	CPI	0FFH

	RZ

	CALL	LGCHAR

	JMP	LGRLP

** INDEXED JUMP VIA (A)

LGINX:	XTHL		; NEXT ADDR FROM STACK

	PUSH	D

	MOV	E,A	; INDEX VALUE

	MVI	D,0

	DAD	D	; ADD TO BASE LOCATION

	MOV	E,M	; GET DESIRED OFFSET

	DAD	D	; FORM JUMP ADDRESS

	POP	D

	XTHL		; JUMP IS NOW RETURN

	RET

* SET LGDEN AND LGNCHL FOR DENSITY, WIDTH, OR DOTS

LGFIX:	PUSH	H

	PUSH	D

	PUSH	PSW

	LXI	H,LGWMAT ; WIDTH MATRIX

	LDA	LGCURD	; CURRENT DOT DENSITY

	ADD	A

	ADD	A	; A * 4

	CALL	DADA

	MOV	A,M	; DENSITY SET CHARACTER

	STA	LGDEN

	INX	H

	LDA	LGDSW	; 6/8 DOT SWITCH

	CALL	DADA

	LDA	LGCURW

	MOV	E,A

	MOV	A,M	; CHARACTERS PER LINE

	MVI	D,0

LGWLP:	INR	D

	SUB	E

	JNC	LGWLP

	DCR	D

	MOV	A,D

LGWDNX: STA	LGNCHL	; ACTUAL # CHAR/LINE

	POP	PSW

	POP	D

	POP	H

	RET

 IF NC

* MAKE ASCII FROM BINARY, SEND TO PRINTER

LGUDD4: LXI	D,-1000

	CALL	LGDIV

LGUDD3: LXI	D,-100

	CALL	LGDIV

LGUDD2: LXI	D,-10

	CALL	LGDIV

LGUDD1: LXI	D,-1

LGDIV:	LHLD	LGVAL

	XRA	A

LGDIV1: DAD	D

	JNC	LGDIV2

	INR	A

	SHLD	LGVAL

	JMP	LGDIV1

LGDIV2: ADI	'0'

	CALL	LGCHAR

	RET

 ENDIF

* SEND INLINE TEXT TO PRINTER

LGCHAR: PUSH	B

	PUSH	D

	PUSH	H

	MOV	C,A

	CALL	LGOUT

	POP	H

	POP	D

	POP	B

	RET

* ADD A TO H,L

DADA:	ADD	L

	MOV	L,A

	RNC

	INR	H

	RET

* FIX UP CALLING PATCH

SIGNON: POP	H	; GET RETURN ADDRESS

	PUSH	B	; SAVE THEIR CHARACTER

	PUSH	H

	INX	H

	INX	H

	MOV	E,M	; CRTOUT ADDRESS

	INX	H

	MOV	D,M

	XCHG

	SHLD	CRTAD+1 ; USE FOR SHOWING MESSAGE

	POP	H

	DCX	H

	DCX	H

	PUSH	H	; CALL ADDRESS LOCATION

	DCX	H

	DCX	H

	DCX	H

	DCX	H

	SHLD	CONAD+1 ; FIX RETURN JMP

	LHLD	RSTAD

	XCHG

	POP	H

	MOV	M,E	; RESTORE CALL ADDR

	INX	H

	MOV	M,D

* BROADCAST OUR PRESENCE

	LXI	H,LGBUF

LGMGL:	MOV	C,M

	INX	H

	MVI	A,'$'

	CMP	C

	JZ	MSGXIT

	PUSH	H

CRTAD:	CALL	0000H

	POP	H

	JMP	LGMGL

MSGXIT: POP	B

CONAD:	JMP	0000H	; GOTO CONOUT

** DATA AREA

PARAMS	DB	34	; VERSION 3.4

LGCCC	DB	'\'	; CONVERSION CHARACTER

** ORDERED VALUES,  DO NOT CHANGE ORDER BELOW

LGST	DB	0	; STATE VARIABLE

LGGRFL	DB	0	; 1=>GRAPHICS ON

LGIVFL	DB	0	; 1=>INVERSE

LGNLSW	DB	0	; 1=>SKIP NEXT NEW LINE

LGCURW	DB	1	; 1,2,3,4 ARE OK

LGDH	DB	0	; 0=>NORMAL, 1=>DOUBLE

 IF ML

LGDSW	DB	1	; 0=>8, 1=>6 DOTS/CHAR

 ENDIF

 IF MX

LGDSW	DB	1	; 0=>8, 1=>6 DOTS/CHAR

 ENDIF

 IF NC

LGDSW	DB	0	; 0=>8, 1=>6 DOTS/CHAR

 ENDIF

 IF MPI

LGDSW	DB	0	; 0=>8, 1=>6 DOTS/CHAR

 ENDIF

LGNCHL	DB	80	; CHARACTERS/LINE

** ORDERED VALUES,  DO NOT CHANGE ORDER ABOVE

*    a	Density character

*    b	CHAR/LINE at 8 dots

*    b	CHAR/LINE at 6 dots

 IF MX	;	 a  b  c

LGWMAT: DB	'K',060,080,0	; 60  DOTS/INCH

	DB	'L',096,120,0	; 120

	DB	'y',096,120,0	; 120

	DB	'z',240,255,0	; 240

 ENDIF

 IF ML8292

LGWMAT: DB	30,60,80,0	; 60  DOTS/INCH

	DB	28,72,96,0	; 72

	DB	28,72,96,0	; 72

	DB	28,72,96,0	; 72

 ENDIF

 IF ML84

LGWMAT: DB	30,080,080,0	; 60  DOTS/INCH

	DB	28,122,163,0	; 72

	DB	28,122,163,0	; 72

	DB	28,122,163,0	; 70

 ENDIF

 IF NC

LGWMAT: DB	'N',080,106,0	; 80  DOTS/INCH

	DB	'E',096,127,0	; 96

	DB	'Q',136,181,0	; 136

	DB	'P',160,213,0	; 160

 ENDIF

 IF MPI

LGWMAT: DB	 31,080,109,0	; 82.5 DOTS/INCH

	DB	 30,075,100,0	; 75

	DB	 29,060,080,0	; 60

	DB	 28,050,066,0	; 50

 ENDIF

LGROW	DB	32	; CURRENT ROW

LGDHI	DB	1	; 0=>TOP, 1=>BOTTOM

LGTBID	DB	0	; TOP/BOTTOM FLAG

LGCX	DB	0	; COLUMN COUNTER

LGCNT	DB	0	; CHAR COUNT ON LINE

LGCURD	DB	0	; CURRENT DENSITY

LGOVR	DB	0	; LINE OVERFLOW FLAG

LGCHP	DW	0	; CHARACTER POINTER

LGVAL	DW	0	; BINARY TO ASCII VALUE

* THIS IS LINE BUFFER AT RUN TIME.

LGBUF:	DB	CR,LF,'User Programmable Characters in UL1: for '

 IF MX

	DB	'MX/FX/Gemini'

 ENDIF

 IF ML

	DB	'Microline '

 ENDIF

 IF ML82

	DB	'82'

 ENDIF

 IF ML84

	DB	'84'

 ENDIF

 IF ML92

	DB	'92'

 ENDIF

 IF NC

	DB	'NEC-8023/CITOH-8510'

 ENDIF

 IF MPI

	DB	'MPI'

 ENDIF

	DB	CR,LF,'V3.4 - '

	DB	' (C)1985 Lindley Systems'

	DB	CR,LF,'$'

LGBUFE: DS	256+LGBUF-LGBUFE

**

	DB	'QZ'	; DATA AREA ID FOR CHARFIX

*			  TO PUT THE CHARACTER SET

	DW	0600H

LGDATA: EQU	$

 DB 131,015,063,255,255,255,000,000,000,131,143,191,000,000,063,252

 DB 000,000,000,000,063,252,000,000,004,016,065,004,016,065,130,008

 DB 032,130,008,032,004,016,127,252,016,065,130,008,063,254,008,032

 DB 004,016,065,004,000,000,130,008,063,252,000,000,004,016,127,252

 DB 000,000,130,008,032,128,000,000,000,000,063,252,016,065,000,000

 DB 032,130,008,032,000,000,001,004,016,065,000,000,063,254,008,032

 DB 000,001,004,124,065,000,000,004,016,065,004,000,000,000,130,040

 DB 112,128,000,000,000,128,000,000,169,090,149,169,090,149,169,090

 DB 149,169,090,149,255,255,255,000,000,000,000,000,000,255,255,255

 DB 000,000,064,060,000,064,000,000,032,194,000,000,000,000,000,000

 DB 000,000,000,000,000,255,255,255,000,000,000,000,000,000,255,255

 DB 255,000,000,000,255,255,255,000,000,000,000,000,000,000,000,000

 DB 000,000,000,255,255,255,000,000,000,000,000,000,255,255,255,255

 DB 255,255,000,000,000,000,000,000,000,000,000,255,255,255,000,000

 DB 000,255,255,255,255,255,255,251,140,032,255,206,032,000,000,000

 DB 004,016,065,004,016,065,130,008,063,254,008,032,004,016,127,252

 DB 000,000,130,008,063,252,000,000,004,016,127,252,016,065,130,008

 DB 032,130,008,032,000,000,063,252,016,065,000,000,063,254,008,032

 DB 193,193,131,012,103,048,012,230,048,193,131,131,000,000,001,012

 DB 231,048,012,231,048,128,000,000,193,195,131,004,000,000,000,000

 DB 032,193,195,131,195,012,048,195,012,048,000,000,000,000,000,000

 DB 000,000,000,000,000,000,012,048,195,012,048,195,255,240,000,000

 DB 000,000,255,240,000,000,000,000,000,000,000,000,015,255,000,000

 DB 000,000,015,255,000,067,143,125,244,000,000,000,000,227,128,000

 DB 000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,124

 DB 000,000,000,000,000,064,000,000,000,000,028,001,192,000,000,000

 DB 000,000,000,000,000,001,095,021,241,064,000,000,048,003,000,000

 DB 000,001,010,124,162,064,000,008,032,194,000,000,000,006,025,008

 DB 066,000,000,008,000,003,012,000,000,003,082,052,000,064,000,008

 DB 016,066,004,000,000,000,004,096,000,000,000,000,000,000,000,000

 DB 000,000,000,028,132,000,000,000,000,002,004,000,000,004,008,028

 DB 000,000,000,004,032,000,000,000,000,001,066,060,033,064,000,000

 DB 000,128,000,000,000,000,130,060,032,128,000,000,000,128,000,000

 DB 000,000,000,000,000,000,000,000,052,224,000,000,000,000,130,008

 DB 032,128,000,000,000,000,000,000,000,000,000,000,000,000,000,000

 DB 048,192,000,000,000,000,066,016,132,000,066,000,000,000,000,000

 DB 000,003,209,073,067,192,000,008,016,065,008,000,000,000,008,124

 DB 000,000,000,000,016,193,000,000,000,002,016,069,035,000,000,004

 DB 048,065,004,000,000,004,016,081,164,064,000,008,016,065,008,000

 DB 000,000,197,037,240,064,000,000,000,003,000,000,000,007,020,081

 DB 068,192,000,008,016,065,008,000,000,000,198,041,032,064,000,008

 DB 016,065,008,000,000,004,017,073,070,000,000,000,048,000,000,000

 DB 000,003,082,073,035,064,000,008,016,065,008,000,000,003,018,073

 DB 035,192,000,000,016,066,000,000,000,000,006,024,000,000,000,000

 DB 048,192,000,000,000,000,006,024,000,000,000,000,052,224,000,000

 DB 000,000,002,020,132,000,000,000,000,002,004,000,000,001,069,020

 DB 081,064,000,000,000,000,000,000,000,004,008,020,032,000,000,004

 DB 032,000,000,000,000,002,016,069,035,000,000,000,000,064,000,000

 DB 000,001,200,077,035,192,000,012,008,162,138,000,000,003,210,073

 DB 035,192,000,012,000,000,012,000,000,007,210,073,035,064,000,012

 DB 016,065,008,000,000,003,208,065,002,000,000,008,016,065,008,000

 DB 000,007,208,064,129,192,000,012,016,066,000,000,000,007,210,073

 DB 036,000,000,012,016,065,004,000,000,007,210,073,036,000,000,012

 DB 000,000,000,000,000,003,208,073,036,192,000,008,016,065,012,000

 DB 000,007,194,008,039,192,000,012,000,000,012,000,000,000,016,125

 DB 000,000,000,000,016,193,000,000,000,000,000,065,244,000,000,008

 DB 016,066,000,000,000,007,194,020,132,000,000,012,000,002,004,000

 DB 000,007,192,000,000,000,000,012,016,065,004,000,000,007,200,024

 DB 135,192,000,012,000,000,012,000,000,007,196,008,023,192,000,012

 DB 000,000,012,000,000,003,208,065,003,192,000,008,016,065,008,000

 DB 000,007,210,073,035,000,000,012,000,000,000,000,000,003,208,069

 DB 003,192,000,008,016,066,004,000,000,007,210,077,035,000,000,012

 DB 000,002,004,000,000,003,018,073,034,064,000,008,016,065,008,000

 DB 000,004,016,125,004,000,000,000,000,192,000,000,000,007,192,000

 DB 007,192,000,008,016,065,008,000,000,007,003,000,055,000,000,000

 DB 000,192,000,000,000,007,192,012,007,192,000,008,016,129,008,000

 DB 000,006,005,008,086,000,000,012,000,000,012,000,000,006,004,012

 DB 070,000,000,000,000,192,000,000,000,004,017,073,070,000,000,012

 DB 016,065,004,000,000,000,000,125,004,000,000,000,000,193,004,000

 DB 064,129,002,004,000,000,000,000,000,002,004,000,000,004,016,124

 DB 000,000,000,004,016,192,000,000,000,001,008,064,129,000,000,000

 DB 000,000,000,000,000,000,000,000,000,000,016,065,004,016,065,004

 DB 000,000,024,016,000,000,000,000,000,000,000,000,000,000,005,020

 DB 080,192,000,008,016,065,012,000,000,007,196,016,064,192,000,012

 DB 016,065,008,000,000,000,196,016,064,000,000,008,016,065,000,000

 DB 000,000,196,016,071,192,000,008,016,065,012,000,000,000,197,020

 DB 080,192,000,008,016,065,000,000,000,001,015,081,002,000,000,000

 DB 048,000,000,000,000,000,196,016,033,192,000,008,020,082,078,000

 DB 000,007,196,016,064,192,000,012,000,000,012,000,000,000,004,092

 DB 000,000,000,000,016,193,000,000,000,000,000,001,112,000,000,002

 DB 004,019,128,000,000,007,193,008,080,000,000,012,000,000,012,000

 DB 000,000,016,124,000,000,000,000,016,193,000,000,000,000,196,012

 DB 064,192,000,012,000,192,012,000,000,001,196,016,064,192,000,012

 DB 000,000,012,000,000,000,196,016,064,192,000,008,016,065,008,000

 DB 000,001,194,016,064,192,000,015,032,065,008,000,000,000,196,016

 DB 033,192,000,008,016,066,015,000,000,001,194,016,064,128,000,012

 DB 000,000,000,000,000,000,133,020,080,000,000,000,016,065,008,000

 DB 000,001,031,016,000,000,000,000,032,065,008,000,000,001,192,000

 DB 001,192,000,008,016,066,012,000,000,001,192,000,001,192,000,000

 DB 032,066,000,000,000,001,192,004,001,192,000,008,016,129,008,000

 DB 000,001,002,004,033,000,000,004,032,002,004,000,000,001,192,000

 DB 001,192,000,008,020,082,078,000,000,001,004,020,097,000,000,004

 DB 048,065,004,000,000,000,002,053,004,000,000,000,000,129,004,000

 DB 000,000,000,124,000,000,000,000,000,192,000,000,000,004,016,052

 DB 032,000,000,004,016,128,000,000,000,002,016,032,066,000,000,000

 DB 000,000,000,000,000,003,223,125,243,192,000,008,048,195,008,000

 DB '<-'

	END

